UnicodeAdd      PROTO   :DWORD,:DWORD
UnicodeDel      PROTO   :DWORD
ConvertToHex    PROTO   :DWORD
.data
xlat_table      db      '0123456789ABCDEF'
.code

UnicodeAdd  PROC    lpSource:DWORD,lpString:DWORD

    push    esi
    push    edi
    pushfd
    mov     esi,lpString
    cld
align_to_eos:
    lodsw
    or      al,al
    jnz     align_to_eos
    sub     esi,2
    mov     edi,esi
    mov     esi,lpSource
loop_1:
    lodsw
    cmp     al,0
    je      end_loop_1
    stosw
    jmp     loop_1
end_loop_1:
    stosw
    popfd
    pop     edi
    pop     esi
    ret

UnicodeAdd  endp

UnicodeDel  PROC    lpString:DWORD

    push    esi
    push    edi
    pushfd
    mov     esi,lpString
    cld
loop_1:
    lodsw
    or      al,al    
    jnz     loop_1
    std
loop_2:
    lodsw
    cmp     al,20h
    jne     loop_2
    mov     edi,esi
    add     edi,4
    cld
    xor     ax,ax
    stosw
    popfd
    pop     edi
    pop     esi
    ret

UnicodeDel  endp
    
        
ConvertToHex    PROC    Val:DWORD

    push    eax
    push    ebx
    push    ecx
    push    esi
    push    edi
    pushfd
    mov     eax,Val
    mov     ecx,8
    lea     ebx,xlat_table
    lea     edi,NumBuffer
    cld
loop_1:
    rol     eax,4
    push    eax
    and     eax,1111b
    mov     al,[ebx+eax]
    stosw
    pop     eax
    dec     ecx
    jcxz    end_loop_1
    jmp     loop_1
end_loop_1:
    xor     ah,ah
    mov     al,'H'
    stosw
    xor     al,al
    stosw
    popfd
    pop     edi
    pop     esi
    pop     ecx
    pop     ebx
    pop     eax
    ret

ConvertToHex    endp